import cattura.agents.configuration.model.interfaces.Plugin;
import cattura.agents.configuration.model.interfaces.Plugin.Inject;
import cattura.agents.configuration.model.interfaces.Plugin.On;
import cattura.agents.configuration.model.vos.plugin.PluginInfo;
import java.io.File;
import org.puremvc.java.multicore.patterns.facade.Facade
import cattura.agents.configuration.model.proxies.EnvironmentProxy
import cattura.agents.configuration.model.vos.events.Event
import com.cattura.share.processor.Processor.Subscribe

class MediaInfoPlugin implements Plugin
{
    private static final def ANALYZERS = [
        mediainfo: "mediainfo --output=html {mediaFile}",
        atomicparsley: "AtomicParsley {mediaFile} -T",
        ffprobe: "ffprobe {mediaFile}"
    ];
    public static @Inject.Info PluginInfo _info;
    public static @Inject.Facade Facade _facade;

    @On.Load
    public void onLoad ()
    {
        _info.getLogger().info("MediaInfo Plugin started")
    }

    @Subscribe
    public void onEvent (final Event $event)
    {
        if ($event.getClass().getSimpleName() == "WebServerEvent")
        {
            def MediaInfoHttpHandler = this.class.classLoader.parseClass(_info.getResource("MediaInfoHttpHandler.groovy"))
            $event.getWebServer().add(MediaInfoHttpHandler.newInstance(
                _facade.retrieveProxy(EnvironmentProxy.NAME),
                ANALYZERS
            ))
        }
    }
}

plugin = new MediaInfoPlugin()
